<?php
require_once('config.php');

function create_thumb($name, $filename, $new_w, $new_h) {
	$system = explode(".", $name);
	if(preg_match("/jpg|jpeg/i", $system[count($system) - 1])) {
		$src_img = imagecreatefromjpeg($name);
	}
	if(preg_match("/png/i", $system[count($system) - 1])) {
		$src_img = imagecreatefrompng($name);
	}
	if(!isset($src_img)) {
		return; // not an image
	}
	$old_x = imagesx($src_img);
	$old_y = imagesy($src_img);
	if($old_x > $old_y) {
		$thumb_w = $new_w;
		$thumb_h = $old_y * ($new_h / $old_x);
	}
	if($old_x < $old_y) {
		$thumb_w = $old_x * ($new_w / $old_y);
		$thumb_h = $new_h;
	}
	if($old_x == $old_y) {
		$thumb_w = $new_w;
		$thumb_h = $new_h;
	}
	$dst_img = imagecreatetruecolor($thumb_w, $thumb_h);
	imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $thumb_w, $thumb_h, $old_x, $old_y); 
	if(preg_match("/png/", $system[count($system) - 1])) {
		imagepng($dst_img, $filename);
	} else {
		imagejpeg($dst_img, $filename);
	}
	imagedestroy($dst_img);
	imagedestroy($src_img);
	chmod($filename, 0755);
}

$imageUrl = '';
$uploaded_images = '';

// upload
if(count($_FILES))
{
	// Doublecheck that we really had a file:
	if(!($_FILES['filAttachment']['size'])) {
		die('ERROR: No actual file uploaded!');
	} else {
		// Determine the filename to which we want to save this file:
		if(!is_dir($ne2_config_info['upload_dir'])) {
			mkdir($ne2_config_info['upload_dir'], 0777, TRUE);
		}
		
		$prx = time() . '_';
		$oriname = str_replace(' ', '_', basename($_FILES['filAttachment']['name']));
		$newname = $prx . $oriname;
		$thname = 'thumb_' . $newname;
		$newnamepath = $ne2_config_info['upload_dir'] . $newname;
		$thnamepath = $ne2_config_info['upload_dir'] . $thname;
		// Attempt to move the uploaded file to it's new home:
		if(!(move_uploaded_file($_FILES['filAttachment']['tmp_name'], $newnamepath))) {
			die('ERROR: A problem occurred during file upload!');
		} else {
			// It worked!
			chmod($newnamepath, 0755);
			create_thumb($newnamepath, $thnamepath, 80, 80);
			$imageUrl = '/img/uploaded/' . $newname; // here must be changed when config-entry changed
		}
	}
}

// list uploaded images
$dir = $ne2_config_info['upload_dir'];
if(is_dir($dir)) {
	if($dh = opendir($dir)) {
		while(($file = readdir($dh)) !== FALSE) {
			if(substr($file, 0, 6) == 'thumb_') {
				$file1 = substr($file, 6);
				$uploaded_images .= "<a href='javascript:;' rel='/img/uploaded/$file1'><img alt='' src='/img/uploaded/$file' /></a> ";
			}
		}
		closedir($dh);
	}
}

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Datei hochladen - RRZE NavEditor 2.0 - Prototype</title>
<link rel="stylesheet" type="text/css" href="../css/styles.css" />
<script type="text/javascript" src="../js/jquery-1.2.6.pack.js"></script>
<script type="text/javascript">
<!--
$(document).ready(function() {
	$("#uploadedImgs a").click(function() {
		$("#txtImgUrl").val($(this).attr("rel"));
	});
});
// -->
</script>
</head>

<body>
<div id="wrapper">
	<h1 id="header">Datei hochladen - RRZE NavEditor 2.0 - Prototype</h1>
	
	<div id="contentPanel1">
		<fieldset>
			<legend>Bisherige hochgeladen Bilde</legend>
			<div id="uploadedImgs"><?php echo($uploaded_images); ?></div>
		</fieldset>
		<form action="<?php echo($_SERVER['PHP_SELF']); ?>" method="post" enctype="multipart/form-data" name="frmUpload" id="frmUpload">
			<fieldset>
				<legend>Datei hochladen</legend>
				<label for="filAttachment">Datei:</label>
				<input type="file" id="filAttachment" name="filAttachment" class="textBox" />
				<hr size="1" noshade="noshade" />
				<input type="submit" id="btnUpload" name="btnUpload" value="Hochladen" class="button" />
				<input type="hidden" id="MAX_FILE_SIZE" name="MAX_FILE_SIZE" value="1048576" />
			</fieldset>
			<fieldset>
				<legend>Datei-URL: (zum Copy &amp; Paste)</legend>
				<input type="text" id="txtImgUrl" name="txtImgUrl" class="textBox" onmouseover="this.select();" value="<?php echo($imageUrl); ?>" size="80" />
			</fieldset>
		</form>
	</div>
	
	<div id="footer">&copy; 2007-08 Ke.Chang@rrze.uni-erlangen.de</div>
</div>
</body>

</html>
